#include <OI/oi.H> /*** Hexef.C ***/
#include "Hexef.H"
#include <stdlib.h>
#include <values.h>

		static	OI_class	*my_classp ;		/* ptr to class object for this class */
		static OI_resource resources[] = {
			{ XtNmaximumValue, XtCMaximumValue, XtRInt, sizeof(int), offsetof(HexEntryField,mx_val), 0, 0,
				NULL_PMF, NULL, NULL_PMF, NULL },
		};

 void reg_HexEntryField()
{
	my_classp = OI_register_model_class("HexEntryField", "OI_entry_field", NULL) ;
	return ;
}

 HexEntryField* create_HexEntryField(char *unp, OI_number ln, char *lbp, char *dfp, int mx)
{
		HexEntryField	*p ;

	if ((p = new HexEntryField(unp,ln,lbp,dfp,mx)) && (OI_status<0)) {
		p->del() ;
		p = NULL ;
	}
	return (p) ;
}

 HexEntryField::HexEntryField (
			char		*usr_namp,	/* name of object */
			OI_number	len,		/* # chars displayed in entry field */
			char		*labp,		/* ptr to label for field */
			char		*defp,		/* ptr to default string */
			int		mx)		/* max # chars in entry field */
			: OI_entry_field(my_classp,usr_namp,len,labp,defp,len)
{
	construct(mx) ;
}

 void HexEntryField::construct (
			int	mx)		/* max value allowed */
{
	if (OI_status >= 0) {
		if (! (mx_val = mx))
			mx_val = MAXINT ;
		set_char_chk(this,(OI_ef_char_chk_memfn*)&HexEntryField::char_chk) ;
		set_entry_chk(this,(OI_ef_entry_chk_memfn*)&HexEntryField::entry_chk) ;
	}
}

 OI_ef_char_chk_status HexEntryField::char_chk (OI_entry_field*, void*, OI_number, char c)
{
			OI_ef_char_chk_status	ok ;

	ok = OI_EF_CHAR_CHK_BAD ;
	if ((c != '\0') && isxdigit(c))
		ok = OI_EF_CHAR_CHK_INSERT ;
	return(ok) ;
}

 OI_ef_entry_chk_status HexEntryField::entry_chk (OI_entry_field*, void*)
{
			OI_ef_entry_chk_status	ok ;
			int			n ;

	ok = OI_EF_ENTRY_CHK_OK ;
	if (part_text()) {
		if ((n = atoi(part_text())) > mx_val)
			ok = OI_EF_ENTRY_CHK_BAD ;
	}
	return(ok) ;
}

 void HexEntryField::get_resources()
{
	// get superclass resources first!
	OI_entry_field::get_resources() ;
	conp->rm()->get_resources(resources, OI_count(resources), this, set_resources(), this) ;
	return ;
}
