#include <OI/oi.H> /*** build_forest.C ***/
 main (int argc, char**argv)
{
			void		do_something(OI_menu_cell*, void*, OI_number) ;
			void		configure_format(OI_menu_cell*, void*, OI_number) ;

			OI_connection	*conp ;			// ptr to server connection
			OI_app_window	*wp ;			// ptr to main window
			OI_menu		*mp ;			// ptr to main menu
			OI_menu		*fmt_mp ;		// ptr to page format menu
			OI_static_text	*tp ;			// ptr to text string in main window
			OI_dialog_box	*dbp ;			// ptr to format dialog box
			OI_menu_cell	*cellp ;
		static	OI_cell_spec	file_cells[] = {	// cells in file submenu
				{"read","Read",&do_something,NULL,NULL_PMF,NULL,OI_TEXT_CELL,NULL,0,0,0},
				{"write","Write",&do_something,NULL,NULL_PMF,NULL,OI_TEXT_CELL,NULL,0,0,0},
			} ;
		static	OI_menu_spec	file_menu = {"file_menu",OI_count(file_cells),&file_cells[0],OI_VERTICAL,NULL} ;
		static	OI_cell_spec	opt_cells[] = {		// cells in option submenu
				{"format","Text Format",NULL,NULL,NULL_PMF,NULL,OI_TEXT_CELL,NULL,0,0,0},
				{"printer","Printer Options",NULL,NULL,NULL_PMF,NULL,OI_TEXT_CELL,NULL,0,0,0},
			} ;
		static	OI_menu_spec	opt_menu = {"opt_menu",OI_count(opt_cells),&opt_cells[0],OI_VERTICAL,NULL} ;
		static	OI_cell_spec	main_cells[] = {	// cells in main menu
				{"file","File",NULL,NULL,NULL_PMF,NULL,OI_TEXT_CELL,&file_menu,0,0,0},
				{"option","Options",NULL,NULL,NULL_PMF,NULL,OI_TEXT_CELL,&opt_menu,0,0,0},
			} ;
		static	OI_cell_spec	fmt_cells[] = {		// cells in page format menu
				{"port","Portrait",NULL,NULL,NULL_PMF,NULL,OI_TEXT_CELL,NULL,0,0,0},
				{"land","Landscape",NULL,NULL,NULL_PMF,NULL,OI_TEXT_CELL,NULL,0,0,0},
			} ;

	if (conp = OI_init(&argc, argv, "BuildForest")) {

	 // create main window and set up for laying out interior
		wp = oi_create_app_window("main",200,100,"Main Window") ;
		wp->set_layout(OI_layout_row) ;

	 // create main menu and all submenus and attach to main window
		mp = oi_create_button_menu("main_menu",OI_count(main_cells),&main_cells[0],OI_HORIZONTAL) ;
		wp->set_main_menu(mp) ;

	 // create object for interior of main window and lay it out in main window
		tp = oi_create_static_text("text","Hello, World!") ;
		tp->layout_associated_object(wp,10,10,OI_ACTIVE) ;

	 // create page format dialog box and populate it
		dbp = oi_create_dialog_box("fmt_db",10,10) ;
		dbp->disallow_clip() ;
		dbp->set_title("Page Format") ;
		dbp->set_layout(OI_layout_row) ;

		fmt_mp = oi_create_excl_check_menu("pag_fmt",OI_count(fmt_cells),&fmt_cells[0],OI_HORIZONTAL,"Page Format") ;
		fmt_mp->set_default_cell("port") ;
		fmt_mp->layout_associated_object(dbp,10,10,OI_ACTIVE) ;

	 // page format dialog box uses default cells; attach callback to OK button
		cellp = (OI_menu_cell*) dbp->buttons()->subobject("OK") ;
		cellp->change_action(&configure_format) ;

	 // attach page format dialog box to appropriate menu cell so it will pop up automatically
		dbp->set_associated_object(mp->descendant("format"), OI_DEF_LOC, OI_DEF_LOC, OI_ACTIVE_NOT_DISPLAYED) ;

	 // move main window to root and make it visible
		wp->set_associated_object(wp->root(), OI_DEF_LOC, OI_DEF_LOC, OI_ACTIVE) ;

		OI_begin_interaction() ;
	}
	OI_fini() ;
}

 void do_something(OI_menu_cell *cellp, void*, OI_number)
{
	printf("cell fired:%s\n",cellp->name()) ;
	return ;
}

 void configure_format(OI_menu_cell *cellp, void*, OI_number)
{
	printf("cell fired:%s\n",cellp->name()) ;
	return ;
}
