#include <OI/oi.H>
#include <string.h>

class FOOD: public OI_callback {
	char		val[50];
public:
				FOOD()			{ val[0] = '\0'; }
	char			*value()		{ return (val); }
	void			set_value(char *s)	{ strcpy(val, s); }
	OI_ef_entry_chk_status	validate(OI_entry_field*, void*);
virtual	OI_ef_entry_chk_status	valid(char*) = 0;
};

class FRUIT: public FOOD {
public:
	OI_ef_entry_chk_status	valid(char*);
};

class VEGETABLE: public FOOD {
public:
	OI_ef_entry_chk_status	valid(char*);
};

main (int argc, char **argv)
{
	OI_connection	*conp;				/* the connection to the server */
	OI_app_window	*appWindow;			/* the enclosing app window */
	OI_entry_field	*entryField;			/* the entry field */
	FOOD		*fp;

	if ((conp = OI_init(&argc, argv, "callback", "Callback"))) {
		appWindow = oi_create_app_window("myapp", 10, 10, "C++ callback");
		appWindow->set_layout(OI_layout_row);

		fp = new FRUIT();
		entryField = oi_create_entry_field("fruit", 8, "    Fruit: ", NULL, 8);
		entryField->set_entry_chk(fp, (OI_ef_entry_chk_memfn *)&FOOD::validate);
		entryField->layout_associated_object(appWindow, 0, 0, OI_ACTIVE);
		fp = new VEGETABLE();
		entryField = oi_create_entry_field("fruit", 8, "Vegetable: ", NULL, 8);
		entryField->set_entry_chk(fp, (OI_ef_entry_chk_memfn *)&FOOD::validate);
		entryField->layout_associated_object(appWindow, 0, 1, OI_ACTIVE);

		appWindow->set_associated_object(conp->root(), OI_DEF_LOC, OI_DEF_LOC, OI_ACTIVE);

		OI_begin_interaction();
	}
	OI_fini();
}

OI_ef_entry_chk_status
FOOD::validate(OI_entry_field *efp, void*)
{
	OI_ef_entry_chk_status	ok;
	char			*cp;

	ok = OI_EF_ENTRY_CHK_BAD;
	if (cp = efp->part_text())
		ok = valid(cp);
	return (ok);
}
	
OI_ef_entry_chk_status
FRUIT::valid(char *strp)
{
	static	char		*valid_str[] = { "Apple", "Orange", "Pear", "Peach" };
	const	int		N_STR = (sizeof(valid_str)/sizeof(char *));
	int			i;
	OI_ef_entry_chk_status	ok;

	ok = OI_EF_ENTRY_CHK_BAD;
	for (i = 0; i < N_STR; i++) {
		if (! strcmp(strp, valid_str[i])) {
			ok = OI_EF_ENTRY_CHK_OK;
			break;
		}
	}
	return (ok);
}

OI_ef_entry_chk_status
VEGETABLE::valid(char *strp)
{
-1z	static	char		*valid_str[] = { "Pea", "Bean", "Corn", "Beet" };
	const	int		N_STR = (sizeof(valid_str)/sizeof(char *));
	int			i;
	OI_ef_entry_chk_status	ok;

	ok = OI_EF_ENTRY_CHK_BAD;
	for (i = 0; i < N_STR; i++) {
		if (! strcmp(strp, valid_str[i])) {
			ok = OI_EF_ENTRY_CHK_OK;
			break;
		}
	}
	return (ok);
}
	
	
