#include <OI/oi.H>	/***  transC.C  ***/

static void press(OI_d_tech*, XEvent*, char **, unsigned int*);
static void drag(OI_d_tech*, XEvent*, char **, unsigned int*);
static void release(OI_d_tech*, XEvent*, char **, unsigned int*);

static OI_actions_rec myactions[] = {
	{"press",	press,		NULL, NULL_PMF },
	{"drag",	drag,		NULL, NULL_PMF },
	{"release",	release,	NULL, NULL_PMF },
};

main (int argc, char **argv)
{
	OI_connection	*conp;				/* the connection to the server */
	OI_app_window	*appWindow;			/* the enclosing app window */
	OI_static_text	*staticText;			/* the text label */

	if ((conp = OI_init(&argc, argv, "actions", "Actions"))) {
	        OI_add_actions(myactions, OI_count(myactions));
		appWindow = oi_create_app_window("myapp", 200, 200, "C Translations");
		staticText = oi_create_static_text("label", " Drag Me ");
		staticText->disallow_cut_paste();
		staticText->set_associated_object(appWindow, 5, 5, OI_ACTIVE);
		appWindow->set_associated_object(conp->root(), OI_DEF_LOC, OI_DEF_LOC, OI_ACTIVE);

		OI_begin_interaction();
	}
	OI_fini();
}

int deltaX, deltaY;	/* global variables to hold button press offset */

static void
press(OI_d_tech *objp, XEvent *eventp, char **, unsigned int *)
{
	deltaX = deltaY = 0;
	if (eventp->type == ButtonPress) {
		deltaX = eventp->xbutton.x;
		deltaY = eventp->xbutton.y;
	}
	objp->set_pixels(objp->fg_pixel(), objp->bkg_pixel(), objp->bdr_pixel());
}

static void
drag(OI_d_tech *objp, XEvent *eventp, char **, unsigned int *)
{
	XEvent event;
	if (eventp->type == MotionNotify) {
		event = *eventp;
		while (XCheckTypedEvent(objp->display(), MotionNotify, &event));
		objp->set_loc(event.xmotion.x+objp->loc_x()-deltaX, event.xmotion.y+objp->loc_y()-deltaY);
	}
}

static void
release(OI_d_tech *objp, XEvent *, char **, unsigned int *)
{
	objp->set_pixels(objp->fg_pixel(), objp->bkg_pixel(), objp->bdr_pixel());
}
