/***  transM.C  ***/
#include <OI/oi.H>

class MY_static_text : public OI_static_text {
	protected:
		int	deltaX;
		int	deltaY;
	public:
			MY_static_text(char *nam, char *txt);
		void	press(OI_d_tech*, XEvent*, char **, unsigned int*);
		void	drag(OI_d_tech*, XEvent*, char **, unsigned int*);
		void	release(OI_d_tech*, XEvent*, char **, unsigned int*);
};

static OI_actions_rec myactions[] = {
	{"press",	NULL,	NULL, (OI_translation_memfn *)&MY_static_text::press	},
	{"drag",	NULL,	NULL, (OI_translation_memfn *)&MY_static_text::drag	},
	{"release",	NULL,	NULL, (OI_translation_memfn *)&MY_static_text::release	},
};

MY_static_text::MY_static_text(char *nam, char *txt) : OI_static_text(nam, txt)
{
	push_actions(myactions, OI_count(myactions));
}

main (int argc, char **argv)
{
	OI_connection	*conp;				/* the connection to the server */
	OI_app_window	*appWindow;			/* the enclosing app window */
	MY_static_text	*staticText;			/* the text label */

	if ((conp = OI_init(&argc, argv, "actions", "Actions"))) {
		appWindow = oi_create_app_window("myapp", 200, 200, "C++ Translations");
		staticText = new MY_static_text("label", " Drag Me ");
		staticText->disallow_cut_paste();
		staticText->set_associated_object(appWindow, 5, 5, OI_ACTIVE);
		appWindow->set_associated_object(conp->root(), OI_DEF_LOC, OI_DEF_LOC, OI_ACTIVE);

		OI_begin_interaction();
	}
	OI_fini();
}

void
MY_static_text::press(OI_d_tech *, XEvent *eventp, char **, unsigned int *)
{
	deltaX = deltaY = 0;
	if (eventp->type == ButtonPress) {
		deltaX = eventp->xbutton.x;
		deltaY = eventp->xbutton.y;
	}
	set_pixels(fg_pixel(), bkg_pixel(), bdr_pixel());
}

void
MY_static_text::drag(OI_d_tech *, XEvent *eventp, char **, unsigned int *)
{
	XEvent event;
	if (eventp->type == MotionNotify) {
		event = *eventp;
		while (XCheckTypedEvent(display(), MotionNotify, &event));
		set_loc(event.xmotion.x+loc_x()-deltaX, event.xmotion.y+loc_y()-deltaY);
	}
}

void
MY_static_text::release(OI_d_tech *, XEvent *, char **, unsigned int *)
{
	set_pixels(fg_pixel(), bkg_pixel(), bdr_pixel());
}
